#include <bits/stdc++.h>
using namespace std;

int main () {

long long brPuta, pitanje;
cin>>brPuta>>pitanje;

vector<long long>dan(brPuta);
vector<long long>rbrPakovanja(brPuta);

for (int i=1; i<=brPuta; ++i) {
	cin>>dan[i]>>rbrPakovanja[i];
}
sort (dan.begin(), dan.end());

vector<long long>kraj(pitanje);

long long broj_dana=0;
long long trajanjePakovanja=0;
sort (kraj.begin(), kraj.end());

for (int j=1; j<=pitanje; ++j) {
	cin>>kraj[j];
}

for (int i=1; i<=brPuta; ++i) {
	
	trajanjePakovanja=rbrPakovanja[i]-dan[i];

	if (rbrPakovanja[i]>kraj[i]) {
		trajanjePakovanja=(rbrPakovanja[i]-kraj[i])-trajanjePakovanja;
		cout<<trajanjePakovanja;
	}
}


}